
Ruby - Bug #13802

break inside loop is not working as expected

08/10/2017 08:35 PM - lingarajg (Lingaraj Gowdar)

Status: Rejected   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.1p112 (2016-04-26)

[x86_64-linux-gnu]

Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description

Reproduce process:

1. Create a file (.rb)

2. Add the below code

3. Run with syntax - ruby .rb

your ruby version (ruby -v):

ruby 2.3.1p112 (2016-04-26) [x86_64-linux-gnu]

reproducible ruby script:

y=1

loop do

 y += 1

 next unless y%2==0

 puts y

 break if y > 10

end

 Result of reproduce process:
[Finished in 0.0s]

 Expected result and the reason why you expect:
[Finished in 0.0s]

 Reason is when the condition "y > 10" is met, the code should exit from there, tested with both "break" and "exit". result is same.

History

#1 - 08/11/2017 01:20 PM - MSP-Greg (Greg L)

The code is working as expected.

There are many ways to provide your preferred output.  One way is to place the break statement before the puts statement.

#2 - 08/12/2017 03:58 AM - shevegen (Robert A. Heiler)

Yes, works as the code specifies, not a bug, so misfiled.
I anyone wants to test via copy/paste into IRB, here is a slightly reformatted variant:

y = 1

loop do

  y += 1

  next unless y % 2==0

  puts y

  break if y > 10

end

#3 - 08/12/2017 05:41 AM - nobu (Nobuyoshi Nakada)

- Description updated

- Status changed from Open to Rejected

Files

bug.rb 69 Bytes 08/10/2017 lingarajg (Lingaraj Gowdar)
